<html>
<head>
<title>OgreSimpleRenderable.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
      <li><a href="globals.html"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_aff4b7fb8d70b825eb8a2d7b3cbd2684.html">OgreMain</a>      </li>
      <li class="navelem"><a class="el" href="dir_5049b8c488e02232e72cb8867fab4a28.html">include</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">OgreSimpleRenderable.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="OgreSimpleRenderable_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2012 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">Permission is hereby granted, free of charge, to any person obtaining a copy</span>
<a name="l00010"></a>00010 <span class="comment">of this software and associated documentation files (the &quot;Software&quot;), to deal</span>
<a name="l00011"></a>00011 <span class="comment">in the Software without restriction, including without limitation the rights</span>
<a name="l00012"></a>00012 <span class="comment">to use, copy, modify, merge, publish, distribute, sublicense, and/or sell</span>
<a name="l00013"></a>00013 <span class="comment">copies of the Software, and to permit persons to whom the Software is</span>
<a name="l00014"></a>00014 <span class="comment">furnished to do so, subject to the following conditions:</span>
<a name="l00015"></a>00015 <span class="comment"></span>
<a name="l00016"></a>00016 <span class="comment">The above copyright notice and this permission notice shall be included in</span>
<a name="l00017"></a>00017 <span class="comment">all copies or substantial portions of the Software.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
<a name="l00020"></a>00020 <span class="comment">IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
<a name="l00021"></a>00021 <span class="comment">FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span>
<a name="l00022"></a>00022 <span class="comment">AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
<a name="l00023"></a>00023 <span class="comment">LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span>
<a name="l00024"></a>00024 <span class="comment">OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN</span>
<a name="l00025"></a>00025 <span class="comment">THE SOFTWARE.</span>
<a name="l00026"></a>00026 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00027"></a>00027 <span class="comment">*/</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifndef __SimpleRenderable_H__</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#define __SimpleRenderable_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="OgreMovableObject_8h.html">OgreMovableObject.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="OgreRenderable_8h.html">OgreRenderable.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="OgreAxisAlignedBox_8h.html">OgreAxisAlignedBox.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="OgreMaterial_8h.html">OgreMaterial.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Ogre {
<a name="l00039"></a>00039 
<a name="l00049"></a><a class="code" href="classOgre_1_1SimpleRenderable.html">00049</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#a20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1SimpleRenderable.html" title="Simple implementation of MovableObject and Renderable for single-part custom objects.">SimpleRenderable</a> : <span class="keyword">public</span> <a class="code" href="classOgre_1_1MovableObject.html" title="Abstract class defining a movable object in a scene.">MovableObject</a>, <span class="keyword">public</span> <a class="code" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">protected</span>:
<a name="l00052"></a><a class="code" href="classOgre_1_1SimpleRenderable.html#a27245933f2c80b539d0a255afb3aa5e3">00052</a>         <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a> <a class="code" href="classOgre_1_1SimpleRenderable.html#a27245933f2c80b539d0a255afb3aa5e3">mRenderOp</a>;
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classOgre_1_1SimpleRenderable.html#a68fea25f6baf11e40c88c6ca9a100ca2">00054</a>         <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a> <a class="code" href="classOgre_1_1SimpleRenderable.html#a68fea25f6baf11e40c88c6ca9a100ca2">mWorldTransform</a>;
<a name="l00055"></a><a class="code" href="classOgre_1_1SimpleRenderable.html#aaf40c1de8c700274f5cd419bcada0320">00055</a>         <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a> <a class="code" href="classOgre_1_1SimpleRenderable.html#aaf40c1de8c700274f5cd419bcada0320">mBox</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classOgre_1_1SimpleRenderable.html#a3d77f53493aa7a26856018d62754af6e">00057</a>         <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="code" href="classOgre_1_1SimpleRenderable.html#a3d77f53493aa7a26856018d62754af6e">mMatName</a>;
<a name="l00058"></a><a class="code" href="classOgre_1_1SimpleRenderable.html#a13f60949f0ff2d6aa0fc4744c1f023d9">00058</a>         <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a> <a class="code" href="classOgre_1_1SimpleRenderable.html#a13f60949f0ff2d6aa0fc4744c1f023d9">mMaterial</a>;
<a name="l00059"></a>00059 
<a name="l00061"></a><a class="code" href="classOgre_1_1SimpleRenderable.html#ac63237aaf8dc7b98ca609d062b5daa6a">00061</a>         <a class="code" href="classOgre_1_1SceneManager.html" title="Manages the organisation and rendering of a &#39;scene&#39; i.e.">SceneManager</a> *<a class="code" href="classOgre_1_1SimpleRenderable.html#ac63237aaf8dc7b98ca609d062b5daa6a" title="The scene manager for the current frame.">mParentSceneManager</a>;
<a name="l00062"></a>00062 
<a name="l00064"></a><a class="code" href="classOgre_1_1SimpleRenderable.html#af31fa5d3f45c681d57df7658b1a0ea88">00064</a>         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a> *<a class="code" href="classOgre_1_1SimpleRenderable.html#af31fa5d3f45c681d57df7658b1a0ea88" title="The camera for the current frame.">mCamera</a>;
<a name="l00065"></a>00065 
<a name="l00067"></a><a class="code" href="classOgre_1_1SimpleRenderable.html#a295bb2b641352d1801b805c10f12ecb1">00067</a>         <span class="keyword">static</span> <a class="code" href="namespaceOgre.html#ab6e842a18caf062ed73a5d3badd0dd4c">uint</a> <a class="code" href="classOgre_1_1SimpleRenderable.html#a295bb2b641352d1801b805c10f12ecb1" title="Static member used to automatically generate names for SimpleRendaerable objects.">msGenNameCount</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069     <span class="keyword">public</span>:
<a name="l00071"></a>00071         <a class="code" href="classOgre_1_1SimpleRenderable.html" title="Simple implementation of MovableObject and Renderable for single-part custom objects.">SimpleRenderable</a>();
<a name="l00072"></a>00072 
<a name="l00074"></a>00074         <a class="code" href="classOgre_1_1SimpleRenderable.html" title="Simple implementation of MovableObject and Renderable for single-part custom objects.">SimpleRenderable</a>(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; name);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076         <span class="keywordtype">void</span> setMaterial( <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; matName );
<a name="l00077"></a>00077         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1MaterialPtr.html" title="Specialisation of SharedPtr to allow SharedPtr to be assigned to MaterialPtr.">MaterialPtr</a>&amp; getMaterial(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderOperation( <span class="keyword">const</span> <a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; rend );
<a name="l00080"></a>00080         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getRenderOperation(<a class="code" href="classOgre_1_1RenderOperation.html" title="&#39;New&#39; rendering operation using vertex buffers.">RenderOperation</a>&amp; op);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082         <span class="keywordtype">void</span> setWorldTransform( <span class="keyword">const</span> <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>&amp; xform );
<a name="l00083"></a>00083         <span class="keyword">virtual</span> <span class="keywordtype">void</span> getWorldTransforms( <a class="code" href="classOgre_1_1Matrix4.html" title="Class encapsulating a standard 4x4 homogeneous matrix.">Matrix4</a>* xform ) <span class="keyword">const</span>;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _notifyCurrentCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088         <span class="keywordtype">void</span> setBoundingBox( <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; box );
<a name="l00089"></a>00089         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classOgre_1_1AxisAlignedBox.html" title="A 3D box aligned with the x/y/z axes.">AxisAlignedBox</a>&amp; getBoundingBox(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091         <span class="keyword">virtual</span> <span class="keywordtype">void</span> _updateRenderQueue(<a class="code" href="classOgre_1_1RenderQueue.html" title="Class to manage the scene object rendering queue.">RenderQueue</a>* queue);
<a name="l00093"></a>00093         <span class="keywordtype">void</span> visitRenderables(<a class="code" href="classOgre_1_1Renderable_1_1Visitor.html" title="Visitor object that can be used to iterate over a collection of Renderable instances abstractly...">Renderable::Visitor</a>* visitor, 
<a name="l00094"></a>00094             <span class="keywordtype">bool</span> debugRenderables = <span class="keyword">false</span>);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1SimpleRenderable.html" title="Simple implementation of MovableObject and Renderable for single-part custom objects.">SimpleRenderable</a>();
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00100"></a>00100         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#af73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMovableType(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00101"></a>00101 
<a name="l00103"></a>00103         <span class="keyword">const</span> <a class="code" href="classOgre_1_1HashedVector.html">LightList</a>&amp; getLights(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     };
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="preprocessor">#endif</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span>
</pre></div></div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:52
</p>
</body>
</html>
